import{s as Ee,n as Ue,o as Ae}from"../chunks/scheduler.6062bdaf.js";import{S as Ie,i as Me,g as o,s as a,u as b,A as Se,h as i,f as n,c as m,j as d,v as $,y as A,k as s,o as t,a as h,w as y,d as T,t as P,x as R}from"../chunks/index.7658fce3.js";import{D as F}from"../chunks/Docstring.5ab7be14.js";import{I as De}from"../chunks/IconCopyLink.d844a6a2.js";function je(ze){let c,K,W,Q,u,_,G,w,se,I,Oe="Optimization",Y,f,g,J,L,pe,M,be="ORTOptimizer",Z,r,C,de,S,$e="Handles the ONNX Runtime optimization process for models shared on huggingface.co/models.",le,j,k,he,x,N,ce,q,ye="Computes the dictionary mapping the name of the fused operators to their number of apparition in the model.",ue,v,D,fe,V,Te="Compute the difference in the number of nodes between the original and the optimized model.",_e,z,E,ge,X,Pe=`Compute the dictionary mapping the operators name to the difference in the number of corresponding nodes between
the original and the optimized model.`,xe,O,U,ve,H,Re="Optimizes a model given the optimization specifications defined in <code>optimization_config</code>.",ee,B,te;return w=new De({}),L=new De({}),C=new F({props:{name:"class optimum.onnxruntime.ORTOptimizer",anchor:"optimum.onnxruntime.ORTOptimizer",parameters:[{name:"onnx_model_path",val:": typing.List[os.PathLike]"},{name:"config",val:": PretrainedConfig"},{name:"from_ortmodel",val:": bool = False"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L45"}}),k=new F({props:{name:"from_pretrained",anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained",parameters:[{name:"model_or_path",val:": typing.Union[str, os.PathLike, optimum.onnxruntime.modeling_ort.ORTModel]"},{name:"file_names",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained.model_or_path",description:`<strong>model_or_path</strong> (<code>Union[str, os.PathLike, ORTModel]</code>) &#x2014;
The path to a local directory hosting the model to optimize or an instance of an <code>ORTModel</code> to quantize.
Can be either:<ul>
<li>A path to a local <em>directory</em> containing the model to optimize.</li>
<li>An instance of <a href="/docs/optimum/main/en/onnxruntime/package_reference/modeling_ort#optimum.onnxruntime.ORTModel">ORTModel</a>.</li>
</ul>`,name:"model_or_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.from_pretrained.file_names(Optional[List[str]],",description:`<strong>file_names(<code>Optional[List[str]]</code>,</strong> defaults to <code>None</code>) &#x2014;
The list of file names of the models to optimize.`,name:"file_names(Optional[List[str]],"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L74"}}),N=new F({props:{name:"get_fused_operators",anchor:"optimum.onnxruntime.ORTOptimizer.get_fused_operators",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_fused_operators.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L254",returnDescription:`
<p>The dictionary mapping the name of the fused operators to their number of apparition in the model.</p>
`}}),D=new F({props:{name:"get_nodes_number_difference",anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"},{name:"onnx_optimized_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.get_nodes_number_difference.onnx_optimized_model_path",description:`<strong>onnx_optimized_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the optimized ONNX model.`,name:"onnx_optimized_model_path"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L273",returnDescription:`
<p>The difference in the number of nodes between the original and the optimized model.</p>
`}}),E=new F({props:{name:"get_operators_difference",anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference",parameters:[{name:"onnx_model_path",val:": typing.Union[str, os.PathLike]"},{name:"onnx_optimized_model_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference.onnx_model_path",description:`<strong>onnx_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the ONNX model.`,name:"onnx_model_path"},{anchor:"optimum.onnxruntime.ORTOptimizer.get_operators_difference.onnx_optimized_model_path",description:`<strong>onnx_optimized_model_path</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
Path of the optimized ONNX model.`,name:"onnx_optimized_model_path"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L302",returnDescription:`
<p>The dictionary mapping the operators name to the difference in the number of corresponding nodes between the
original and the optimized model.</p>
`}}),U=new F({props:{name:"optimize",anchor:"optimum.onnxruntime.ORTOptimizer.optimize",parameters:[{name:"optimization_config",val:": OptimizationConfig"},{name:"save_dir",val:": typing.Union[str, os.PathLike]"},{name:"file_suffix",val:": typing.Optional[str] = 'optimized'"},{name:"use_external_data_format",val:": typing.Optional[bool] = None"},{name:"one_external_file",val:": bool = True"}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.optimization_config",description:`<strong>optimization_config</strong> (<a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig">OptimizationConfig</a>) &#x2014;
The configuration containing the parameters related to optimization.`,name:"optimization_config"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.save_dir",description:`<strong>save_dir</strong> (<code>Union[str, os.PathLike]</code>) &#x2014;
The path used to save the optimized model.`,name:"save_dir"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.file_suffix",description:`<strong>file_suffix</strong> (<code>str</code>, defaults to <code>&quot;optimized&quot;</code>) &#x2014;
The file suffix used to save the optimized model.`,name:"file_suffix"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>Optional[bool]</code>, defaults to <code>None</code>) &#x2014;
Whether to use external data format to store model of size &gt;= 2Gb. This argument is deprecated.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTOptimizer.optimize.one_external_file",description:`<strong>one_external_file</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
When <code>use_external_data_format=True</code>, whether to save all tensors to one external file.
If False, save each tensor to a file named with the tensor name.`,name:"one_external_file"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/optimization.py#L127"}}),{c(){c=o("meta"),K=a(),W=o("p"),Q=a(),u=o("h1"),_=o("a"),G=o("span"),b(w.$$.fragment),se=a(),I=o("span"),I.textContent=Oe,Y=a(),f=o("h2"),g=o("a"),J=o("span"),b(L.$$.fragment),pe=a(),M=o("span"),M.textContent=be,Z=a(),r=o("div"),b(C.$$.fragment),de=a(),S=o("p"),S.textContent=$e,le=a(),j=o("div"),b(k.$$.fragment),he=a(),x=o("div"),b(N.$$.fragment),ce=a(),q=o("p"),q.textContent=ye,ue=a(),v=o("div"),b(D.$$.fragment),fe=a(),V=o("p"),V.textContent=Te,_e=a(),z=o("div"),b(E.$$.fragment),ge=a(),X=o("p"),X.textContent=Pe,xe=a(),O=o("div"),b(U.$$.fragment),ve=a(),H=o("p"),H.innerHTML=Re,ee=a(),B=o("p"),this.h()},l(e){const l=Se("svelte-1phssyn",document.head);c=i(l,"META",{name:!0,content:!0}),l.forEach(n),K=m(e),W=i(e,"P",{}),d(W).forEach(n),Q=m(e),u=i(e,"H1",{class:!0});var ne=d(u);_=i(ne,"A",{id:!0,class:!0,href:!0});var we=d(_);G=i(we,"SPAN",{});var Le=d(G);$(w.$$.fragment,Le),Le.forEach(n),we.forEach(n),se=m(ne),I=i(ne,"SPAN",{"data-svelte-h":!0}),A(I)!=="svelte-1jvrjc2"&&(I.textContent=Oe),ne.forEach(n),Y=m(e),f=i(e,"H2",{class:!0});var oe=d(f);g=i(oe,"A",{id:!0,class:!0,href:!0});var Ce=d(g);J=i(Ce,"SPAN",{});var ke=d(J);$(L.$$.fragment,ke),ke.forEach(n),Ce.forEach(n),pe=m(oe),M=i(oe,"SPAN",{"data-svelte-h":!0}),A(M)!=="svelte-1kgc4xj"&&(M.textContent=be),oe.forEach(n),Z=m(e),r=i(e,"DIV",{class:!0});var p=d(r);$(C.$$.fragment,p),de=m(p),S=i(p,"P",{"data-svelte-h":!0}),A(S)!=="svelte-grwr9f"&&(S.textContent=$e),le=m(p),j=i(p,"DIV",{class:!0});var Ne=d(j);$(k.$$.fragment,Ne),Ne.forEach(n),he=m(p),x=i(p,"DIV",{class:!0});var ie=d(x);$(N.$$.fragment,ie),ce=m(ie),q=i(ie,"P",{"data-svelte-h":!0}),A(q)!=="svelte-yjxy0i"&&(q.textContent=ye),ie.forEach(n),ue=m(p),v=i(p,"DIV",{class:!0});var re=d(v);$(D.$$.fragment,re),fe=m(re),V=i(re,"P",{"data-svelte-h":!0}),A(V)!=="svelte-nuojg2"&&(V.textContent=Te),re.forEach(n),_e=m(p),z=i(p,"DIV",{class:!0});var ae=d(z);$(E.$$.fragment,ae),ge=m(ae),X=i(ae,"P",{"data-svelte-h":!0}),A(X)!=="svelte-1qznsek"&&(X.textContent=Pe),ae.forEach(n),xe=m(p),O=i(p,"DIV",{class:!0});var me=d(O);$(U.$$.fragment,me),ve=m(me),H=i(me,"P",{"data-svelte-h":!0}),A(H)!=="svelte-akjqps"&&(H.innerHTML=Re),me.forEach(n),p.forEach(n),ee=m(e),B=i(e,"P",{}),d(B).forEach(n),this.h()},h(){s(c,"name","hf:doc:metadata"),s(c,"content",JSON.stringify(qe)),s(_,"id","optimization"),s(_,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(_,"href","#optimization"),s(u,"class","relative group"),s(g,"id","optimum.onnxruntime.ORTOptimizer"),s(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(g,"href","#optimum.onnxruntime.ORTOptimizer"),s(f,"class","relative group"),s(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(r,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,l){t(document.head,c),h(e,K,l),h(e,W,l),h(e,Q,l),h(e,u,l),t(u,_),t(_,G),y(w,G,null),t(u,se),t(u,I),h(e,Y,l),h(e,f,l),t(f,g),t(g,J),y(L,J,null),t(f,pe),t(f,M),h(e,Z,l),h(e,r,l),y(C,r,null),t(r,de),t(r,S),t(r,le),t(r,j),y(k,j,null),t(r,he),t(r,x),y(N,x,null),t(x,ce),t(x,q),t(r,ue),t(r,v),y(D,v,null),t(v,fe),t(v,V),t(r,_e),t(r,z),y(E,z,null),t(z,ge),t(z,X),t(r,xe),t(r,O),y(U,O,null),t(O,ve),t(O,H),h(e,ee,l),h(e,B,l),te=!0},p:Ue,i(e){te||(T(w.$$.fragment,e),T(L.$$.fragment,e),T(C.$$.fragment,e),T(k.$$.fragment,e),T(N.$$.fragment,e),T(D.$$.fragment,e),T(E.$$.fragment,e),T(U.$$.fragment,e),te=!0)},o(e){P(w.$$.fragment,e),P(L.$$.fragment,e),P(C.$$.fragment,e),P(k.$$.fragment,e),P(N.$$.fragment,e),P(D.$$.fragment,e),P(E.$$.fragment,e),P(U.$$.fragment,e),te=!1},d(e){e&&(n(K),n(W),n(Q),n(u),n(Y),n(f),n(Z),n(r),n(ee),n(B)),n(c),R(w),R(L),R(C),R(k),R(N),R(D),R(E),R(U)}}}const qe={local:"optimization",sections:[{local:"optimum.onnxruntime.ORTOptimizer",title:"ORTOptimizer"}],title:"Optimization"};function Ve(ze){return Ae(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ge extends Ie{constructor(c){super(),Me(this,c,Ve,je,Ee,{})}}export{Ge as component};
